--done
data Token = Num Int | Op Char | Bool Bool | Par Char deriving (Show)

parser :: [Char] -> [Token]
parser [] = []
parser (a:as)
	| elem a "()"         = Par a: parser as
	| elem a "+-*/^&|"    = Op a: parser as
	| elem a "T"          = Bool True: parser as
	| elem a "F"          = Bool False: parser as
	| elem a ['0'..'9']   = Num (aux $ getNum $ takeWhile (`elem` ['0'..'9']) (a:as)) : parser (drop ((length $ takeWhile (`elem` ['0'..'9']) (a:as)) -1) as) 
	| otherwise           = parser as

aux :: (Show a) => [a] -> Int
aux lista = read (concat (map show lista)) :: Int

getNum :: [Char] -> [Int]
getNum [] = []
getNum (a:as) = (read [a] :: Int) : getNum as

--Caso teste
--parser "False&True"
--parser "(2^2)+22*222"