--done
data Tree a = EmptyTree | Node a (Tree a) (Tree a) deriving (Show, Read, Eq)

singleTon :: a -> Tree a
singleTon x = Node x EmptyTree EmptyTree

treeFill :: (Ord a) => [a] -> Tree a -> Tree a
treeFill [] tree = tree
treeFill (a:as) tree = treeFill as (treeInsert a tree)

treeInsert :: (Ord a) => a -> Tree a -> Tree a
treeInsert x EmptyTree = singleTon x
treeInsert x (Node a left right)
	| x == a = Node x left right
	| x < a  = Node a (treeInsert x left) right
	| x > a  = Node a left (treeInsert x right)
	
sort :: (Ord a) => [a] -> [a]
sort [] = []
sort lista = sortTreeToList(treeFill lista EmptyTree)
	
sortTreeToList :: (Ord a) => Tree a -> [a]
sortTreeToList EmptyTree = []
sortTreeToList (Node x left right) = (sortTreeToList left) ++ [x] ++ (sortTreeToList right) 
	
--Caso de teste
--sort [Ord a]