--done
import Data.Char (toLower, toUpper)

search :: [Char] -> [[Char]] -> [Char]
search str [] = lowerCase str
search str (a:as)
	| a == str       = upperCase str
	| otherwise      = search str as
	
searchIgnoreCase :: [Char] -> [[Char]] -> [Char]
searchIgnoreCase str [] = lowerCase str
searchIgnoreCase str (a:as)
	| lowerCase a == lowerCase str       = upperCase str
	| otherwise                          = searchIgnoreCase str as
	
map' :: (a -> b) -> [a] -> [b]
map' _ [] = []
map' f (a:as) = f a : map' f as 

lowerCase :: [Char] -> [Char]
lowerCase lista = map' toLower lista

upperCase :: [Char] -> [Char]
upperCase lista = map' toUpper lista

--Caso teste
--searchIgnoreCase "Paradigmas" ["Programacao", "LiNguaGens", "ParaDigMas"]
--searchIgnoreCase "Programa" ["Programacao", "LiNguaGens", "ParaDigMas"]
--search "Paradigmas" ["Programacao", "LiNguaGens", "ParaDigMas"]
--search "Paradigmas" ["Programacao", "LiNguaGens", "ParaDigMas", "Paradigmas]
--searchIgnoreCase "Programa" ["Programa", "LiNguaGens", "ParaDigMas"]