--done
import Data.List

main :: IO ()
main = putStrLn "Lendo o arquivo" >> getLine >>= \path -> readFile (path) >>= \x -> writeFile "out.txt" (programa x)

programa :: [Char] -> [Char]
programa string = unlines $ quickSort $ formata (funcao (separa (removePontuacao string)))

formata :: [[Char]] -> [[Char]]
formata [] = []
formata ([]:as) = formata as
formata (a:as) = ("--"++ a ++" - palindromo" ): formata as

funcao :: [[Char]] -> [[Char]]
funcao [] = []
funcao (a:as) = palindromo a : funcao as

separa :: [Char] -> [[Char]]
separa lista = words lista

removePontuacao :: [Char] -> [Char]
removePontuacao [] = []
removePontuacao (a:as)
	| elem a ".,?!:;-\"'()[]{}" = removePontuacao as
	| otherwise = a : removePontuacao as

palindromo :: [Char] -> [Char]
palindromo lista 
	| lista == (reverse' lista) = lista
	| otherwise                = []
	
reverse' :: [a] -> [a]
reverse' [] = []
reverse' lista = last lista : reverse' (init lista)

quickSort :: (Ord a) => [a] -> [a]
quickSort [] = []
quickSort (x:xs) = smallerSorted ++ [x] ++ biggerSorted 
	where 
	smallerSorted = quickSort [c | c <- xs, c <= x]
	biggerSorted = quickSort [c | c <- xs, c > x]

